/*
 * @Cameron Giarrusso APCS Property Mar 23, 2017
 */
package Monopoly.Board.Space;

/**
 *
 * @author fcg
 */
public enum Property implements Space {
    MEDITERRANEAN_AVENUE(1, "Mediterranean Avenue", "BROWN", 60, 2),
    BALTIC_AVENUE(3, "Baltic Avenue", "BROWN", 60, 4),
    ORIENTAL_AVENUE(6, "Oriental Avenue", "LIGHT_BLUE", 100, 6),
    VERMONT_AVENUE(8, "Vermont Avenue", "LIGHT", 100, 6),
    CONNETICUT_AVENUE(9, "Connecticut Avenue", "LIGHT", 120, 8),
    ST_CHARLES_PLACE(11, "St. Charles Place", "PINK", 140, 10),
    STATES_AVENUE(13, "States Avenue", "PINK", 140, 10),
    VIRGINIA_AVENUE(14, "Virginia Avenue", "PINK", 160, 12),
    ST_JAMES_PLACE(16, "St. James Place", "ORANGE", 180, 14),
    TENNESSEE_AVENUE(18, "Tennessee Avenue", "ORANGE", 180, 14),
    NEW_YORK_AVENUE(19, "New York Avenue", "ORANGE", 200, 16),
    KENTUCKY_AVENUE(21, "Kentucky Avenue", "RED", 220, 18),
    INDIANA_AVENUE(23, "Indiana Avenue", "RED", 220, 18),
    ILLINOIS_AVENUE(24, "Illinois Avenue", "RED", 240, 20),
    ATLANTIC_AVENUE(26, "Atlantic Avenue", "YELLOW", 260, 22),
    VENTNOR_AVENUE(27, "Ventnor Avenue", "YELLOW", 260, 22),
    MARVIN_GARDENS(29, "Marvin Gardens", "YELLOW", 280, 24),
    PACIFIC_AVENUE(31, "Pacific Avenue", "GREEN", 300, 26),
    NORTH_CAROLINA_AVENUE(32, "North Carolina Avenue", "GREEN", 300, 26),
    PENNSYLVANIA_AVENUE(34, "Pennsylvania Avenue", "GREEN", 320, 28),
    PARK_PLACE(37, "Park Place", "BLUE", 350, 35),
    BOARDWALK(39, "Boardwalk", "BLUE", 400, 50);

    private int space, cost, rent, landed, paid;
    private String name, color;

    private Property(int space, String name, String color, int cost, int rent) {
        this.space = space;
        this.name = name;
        this.color = color;
        this.cost = cost;
        this.rent = rent;
        landed = 0;
        paid = 0;
    }

    public int getSpace() {
        return space;
    }

    public int getCost() {
        return cost;
    }

    public int getRent() {
        return rent;
    }

    public String getName() {
        return name;
    }

    public String getColor() {
        return color;
    }
    
    public boolean isOwnable(){
        return true;
    }
    
    public void setLanded(int landed){
        this.landed = landed;
    }
    
    public int getLanded(){
        return landed;
    }
    
    public void addLanded(){
       this.landed++;
    }
    
    public void setPaid(int paid){
        this.paid = paid;
    }
    
    public int getPaid(){
        return paid;
    }
    
    
    

    public int distanceTo(Space space) {
        if (space.getSpace() > this.space) {
            return space.getSpace() - this.space;
        } else {
            return space.getSpace() + 40 - this.space;
        }
    }

}
