/*
 * @Cameron Giarrusso APCS Special Mar 27, 2017
 */
package Monopoly.Board.Space;

/**
 *
 * @author fcg
 */
public enum Special implements Space {
    GO(0, "Go", false),
    COMMUNITY_CHEST_1(2, "Community Chest", false),
    INCOME_TAX(4, "Income Tax", false),
    READING_RAILROAD(5, "Reading Railroad", true),
    CHANCE_1(7, "Chance", false),
    JAIL(10, "Jail / Just Visiting", false),
    ELECTRIC_COMPANY(12, "Electric Company", true),
    PENNSYLVANIA_RAILROAD(15, "Pennsylvania Railroad", true),
    COMMUNITY_CHEST_2(17, "Community Chest", false),
    FREE_PARKING(20, "Free Parking", false),
    CHANCE_2(22, "Chance", false),
    BO_RAILROAD(25, "B&O Railroad", true),
    WATER_WORKS(28, "Water Works", true),
    GO_TO_JAIL(30, "Go To Jail", false),
    COMMUNITY_CHEST_3(33, "Community Chest", false),
    SHORT_LINE(35, "Short Line", true),
    CHANCE_3(36, "Chance", false),
    LUXURY_TAX(38, "Luxury Tax", false);

    private int space, landed = 0;
    private String name;
    private boolean ownable;

    private Special(int space, String name, boolean ownable) {
        this.space = space;
        this.name = name;
        this.ownable = ownable;
    }

    public boolean isOwnable(){
        return ownable;
    }
    
    public int getSpace() {
        return space;
    }

    public String getName() {
        return name;
    }
    
    public int getLanded(){
        return landed;
    }
    
    public void setLanded(int landed){
        this.landed = landed;
    }
    
    public void addLanded(){
        this.landed++;
    }

    public int distanceTo(Space space) {
        if (space.getSpace() > this.space) {
            return space.getSpace() - this.space;
        } else {
            return space.getSpace() + 40 - this.space;
        }
    }
    

}
